Bug 235203 - Xorg crashes on startup since updating 2019-01-24
Summary: Xorg crashes on startup since updating 2019-01-24
Status: In Progress
Alias: None
Product: Ports & Packages
Classification: Unclassified
Component: Individual Port(s) (show other bugs)
Version: Latest
Hardware: Any Any
: --- Affects Some People
Assignee: freebsd-x11 mailing list
URL:
Keywords: i915, regression
Depends on:
Blocks: 233034
  Show dependency treegraph
 
Reported: 2019-01-25 20:19 UTC by Jason W. Bacon
Modified: 2019-11-27 04:38 UTC (History)
1 user (show)

See Also:


Attachments
Xorg log (15.53 KB, text/plain)
2019-01-25 20:19 UTC, Jason W. Bacon
no flags Details

Note You need to log in before you can comment on or make changes to this bug.
Description Jason W. Bacon freebsd_committer 2019-01-25 20:19:47 UTC
Created attachment 201399 [details]
Xorg log

Running on a Lenovo X201 with Intel video.

vgapci0@pci0:0:2:0:     class=0x030000 card=0x215a17aa chip=0x00468086 rev=0x02 hdr=0x00
    vendor     = 'Intel Corporation'
    device     = 'Core Processor Integrated Graphics Controller'
    class      = display
    subclass   = VGA

FreeBSD mako.acadix.biz 11.2-RELEASE-p8 FreeBSD 11.2-RELEASE-p8 #0: Tue Jan  8 21:35:12 UTC 2019     root@amd64-builder.daemonology.net:/usr/obj/usr/src/sys/GENERIC  amd64

rc.conf:

kld_list="i915kms"

Xorg has always worked fine and no configuration changes were made, but after running pkg upgrade yesterday, Xorg crashes on startup.  Xorg log attached.

I tried switching to graphics/drm-kmod and /boot/modules/i915kms.ko, but this causes a panic instead.

Worked around it for now by installing the xf86-video-intel package.
Comment 1 Jason W. Bacon freebsd_committer 2019-01-27 14:12:46 UTC
Same issue on a ThinkCenter M92p, also using modesetting driver from base.  In this case, switching to drm-kmod resolved the issue.

pciconf -lv:

vgapci0@pci0:0:2:0:     class=0x030000 card=0x308617aa chip=0x01528086 rev=0x09 hdr=0x00
    vendor     = 'Intel Corporation'
    device     = 'Xeon E3-1200 v2/3rd Gen Core processor Graphics Controller'
    class      = display
    subclass   = VGA

Xorg.0.log:

[    59.092] (--) PCI:*(0:0:2:0) 8086:0152:17aa:3086 rev 9, Mem @ 0xf7800000/4194304, 0xe0000000/268435456, I/O @ 0x0000f000/64, BIOS @ 0x????????/65536

1. pkg install drm-kmod

2. In rc.conf, change kld_list="i915kms" to kld_list="/boot/modules/i915kms.ko"

I would consider this a more or less permanent fix, pending the future organization of DRM modules.

It would still be good to know why the new xorg is apparently incompatible with the base i915 module, since the newer module causes a panic on my X201 and running the obsolete xf86-video-intel driver is probably not sustainable.
Comment 2 Mark Linimon freebsd_committer freebsd_triage 2019-02-07 11:12:01 UTC
Override bogus default assignment.
Comment 3 Jan Beich freebsd_committer 2019-02-07 11:47:36 UTC
Likely a duplicate of bug 235487. Thank you for documenting workarounds.
Comment 4 Jan Beich freebsd_committer 2019-02-19 00:01:51 UTC
(In reply to Jason W. Bacon from comment #0)
> I tried switching to graphics/drm-kmod and /boot/modules/i915kms.ko,
> but this causes a panic instead.

Can you report the panic to https://github.com/FreeBSDDesktop/kms-drm/issues/ ? Also try newer FreeBSD version (or just kernel) which supports newer drm-*-kmod.

Probably all hardware supported by drm2 (i915kms, radeonkms) from base or drm-legacy-kmod is supposed to work with drm-kmod. Obviously, there're bugs because the focus is on recent hardware, usually *not* supported by drm2.

(In reply to Jason W. Bacon from comment #1)
> Same issue on a ThinkCenter M92p, also using modesetting driver from
> base.  In this case, switching to drm-kmod resolved the issue.

SandyBridge is known to work on drm-kmod, so IvyBridge also working isn't surprising. Did you test on the same FreeBSD version? I'm curious if drm-fbsd11.2-kmod is less stable on old hardware.
Comment 5 Jason W. Bacon freebsd_committer 2019-02-27 16:43:53 UTC
Added a comment at

https://github.com/FreeBSDDesktop/kms-drm/issues/94

Good to know the new drm-kmod is at least intended to work on all common hardware.

I plan to upgrade all my desktop/laptop systems to 12.0-RELEASE, but I'll keep this one on 11.2 for now to help debug this issue.

If I can find time I'll try installing 12.0 on an external disk for testing.

Thanks.
Comment 6 Jason W. Bacon freebsd_committer 2019-02-27 20:03:43 UTC
Saw what appeared to be the same issue on a Toshiba Satellite L305.  Upgrading from 11.2 to 12.0 resolved it (the drm-kmod package works fine now).
Comment 7 Jason W. Bacon freebsd_committer 2019-02-28 15:16:03 UTC
FYI, further discussion will be happening at https://github.com/FreeBSDDesktop/kms-drm/issues/94.
Comment 8 Jason W. Bacon freebsd_committer 2019-03-25 01:58:55 UTC
To answer Jan's last question, yes both the X201 and the M92P are running 11.2-RELEASE.
Comment 9 Niclas Zeising freebsd_committer 2019-07-29 12:47:42 UTC
Is this still an issue, even with updated grapics drivers from drm-kmod?
Comment 10 Jason W. Bacon freebsd_committer 2019-07-29 14:00:36 UTC
No change.

Still panics when loading /boot/modules/i915kms.ko.

Base i915kms loads successfully, but Xorg exits on signal 6 if using modesetting driver.

Works fine using base i915kms + xf86-video-intel.
Comment 11 Niclas Zeising freebsd_committer 2019-07-29 14:09:14 UTC
Which drm-kmod package is installed, can you give a list?
The drm driver in base on FreeBSD 12 and the one in drm-legacy-kmod are virtually the same.  On FreeBSD 11 drm-legacy-kmod isn't available.
Comment 12 Jason W. Bacon freebsd_committer 2019-07-29 14:16:24 UTC
FreeBSD mako.acadix  bacon ~ 1004: pkg info | grep drm
drm-fbsd11.2-kmod-4.11g20190424 DRM modules for the linuxkpi-based KMS components
drm-kmod-g20190710             Metaport of DRM modules for the linuxkpi-based KMS components
libdrm-2.4.98_1,1              Userspace interface to kernel Direct Rendering Module services

FreeBSD mako.acadix  bacon ~ 1005: uname -a
FreeBSD mako.acadix.biz 11.2-RELEASE-p12 FreeBSD 11.2-RELEASE-p12 #0: Tue Jul 23 19:46:42 UTC 2019     root@amd64-builder.daemonology.net:/usr/obj/usr/src/sys/GENERIC  amd64
Comment 13 Niclas Zeising freebsd_committer 2019-07-29 14:23:07 UTC
(In reply to Jason W. Bacon from comment #12)
> FreeBSD mako.acadix  bacon ~ 1004: pkg info | grep drm
> drm-fbsd11.2-kmod-4.11g20190424 DRM modules for the linuxkpi-based KMS
> components
> drm-kmod-g20190710             Metaport of DRM modules for the
> linuxkpi-based KMS components
> libdrm-2.4.98_1,1              Userspace interface to kernel Direct
> Rendering Module services
> 
> FreeBSD mako.acadix  bacon ~ 1005: uname -a
> FreeBSD mako.acadix.biz 11.2-RELEASE-p12 FreeBSD 11.2-RELEASE-p12 #0: Tue
> Jul 23 19:46:42 UTC 2019    
> root@amd64-builder.daemonology.net:/usr/obj/usr/src/sys/GENERIC  amd64

Have you tried on FreeBSD 12?  The ports driver for FreeBSD 12 is newer, and a lot of things have happened, both in the lkpi itself, and the driver, that this might be something that's fixed in later versions.
Comment 14 Jason W. Bacon freebsd_committer 2019-07-29 23:46:50 UTC
Upgrading to 12.0 fixed the issue on a Toshiba Satellite (as I mentioned earlier) and also on my ThinkCenter M92P-Tiny.

I delayed upgrading the X201 to allow time to resolve this PR and the panic issue.